include masm32rt.inc
include gdip.inc
include gdiplus.inc
includelib gdiplus.lib
.686p
.mmx
.xmm

include unicode.inc

WndProc 	proto :DWORD,:DWORD,:DWORD,:DWORD

WND_DATA struct
	hdc			HDC 	?
	dwOffset	DWORD	?
	ppwsz		PWCHAR	?
	nLines		DWORD	?
WND_DATA ends

.data?
	hInstance	dd ?
	
.data
	WSTR wszTitel, 	"A long time ago in a galaxy far, far away",13,10
	WSTR,			"It is a period of civil war. Rebel spaceships, striking from a",13,10
 	WSTR,			"hidden base, have won their first victory against the evil Galactic",13,10
 	WSTR,			"Empire.",13,10
 	WSTR,			"During the battle, Rebel spies managed to steal secret plans to the",13,10
 	WSTR,			"Empire's ultimate weapon, the Death Star, an armored space station",13,10
 	WSTR,			"with enough power to destroy an entire planet.",13,10
	WSTR, 			"Pursued by the Empire's sinister agents, Princess Leia races home",13,10
 	WSTR,			"aboard her starship, custodian of the stolen plans that can save her",13,10
 	WSTR,			"people and restore freedom to the galaxy...",0
	
.code
main proc 
LOCAL wcex:WNDCLASSEX
LOCAL msg:MSG
LOCAL gsi:GdiplusStartupInput
LOCAL gtkn:PULONG

	mov gsi.GdiplusVersion,1
	mov gsi.DebugEventCallback,0
	mov gsi.SuppressBackgroundThread,0
	mov gsi.SuppressExternalCodecs,0
	invoke GdiplusStartup,ADDR gtkn,ADDR gsi,0

	mov hInstance,rv(GetModuleHandle,0)
	mov wcex.hInstance,eax
	mov wcex.cbSize,SIZEOF WNDCLASSEX
	mov wcex.style, CS_HREDRAW or CS_VREDRAW
	mov wcex.lpfnWndProc, OFFSET WndProc
	mov wcex.cbClsExtra,NULL
	mov wcex.cbWndExtra,SIZEOF WND_DATA
	mov wcex.hbrBackground,0
	mov wcex.lpszMenuName,NULL
	mov wcex.lpszClassName,chr$("Win32Gdi+")
	mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wcex.hIconSm,eax
	mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	invoke RegisterClassEx, ADDR wcex
	mov esi,rv(CreateWindowEx,NULL,wcex.lpszClassName,"GDI+",WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,hInstance,NULL)
	invoke ShowWindow,esi,SW_SHOWNORMAL
	invoke UpdateWindow,esi

	.while 1
		invoke GetMessage,ADDR msg,NULL,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw
	
	invoke GdiplusShutdown,gtkn
	invoke ExitProcess,msg.wParam

main endp

wszLine proc uses ebx pwsz:ptr WCHAR
	
	xor ecx,ecx
	mov ebx,pwsz
	.while WCHAR ptr [ebx+ecx*2]
		.if WCHAR ptr [ebx+ecx*2] == 13 && WCHAR ptr [ebx+ecx*2+2] == 10
			lea eax,[ebx+ecx*2+2+2]
			ret
		.endif
		inc ecx
	.endw
	xor eax,eax
	ret	
	
wszLine endp

wszLineCnt proc uses ebx pwsz: ptr WCHAR

	xor ecx,ecx
	xor edx,edx
	mov ebx,pwsz
	.while WCHAR ptr [ebx]
		.if WCHAR ptr [ebx] == 13 && WCHAR ptr [ebx+2] == 10
			inc ecx
			xor edx,edx
			add ebx,4
			.continue
		.endif
		inc edx
		add ebx,2
	.endw
	.if edx
		lea eax,[ecx+1]
	.else
		mov eax,ecx
	.endif
	ret	

wszLineCnt endp

wszLineArray proc uses ebx esi edi pwsz: ptr WCHAR
LOCAL cntLines:DWORD
	mov cntLines,rv(wszLineCnt,pwsz)
	.if cntLines
		mov edi,alloc(ADDR [eax*PWCHAR])
		mov ebx,pwsz
		xor esi,esi
		.while esi < cntLines
			invoke wszLine,ebx
			push eax
			push ecx
			mov PWCHAR ptr [edi+esi*4],alloc(ADDR [ecx*2+2])
			pop ecx
			.while ecx
				movzx edx,WCHAR ptr [ebx]
				mov WCHAR ptr [eax],dx
				add ebx,2
				add eax,2
				dec ecx
			.endw
			mov WCHAR ptr [eax],0
			pop ebx
			inc esi
		.endw
		mov ecx,cntLines
		mov eax,edi
	.else
		xor ecx,ecx
		xor eax,eax
	.endif
	ret
	
wszLineArray endp


WndProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL ps:PAINTSTRUCT
LOCAL graphics:PVOID
LOCAL pen:PVOID
LOCAL matrix:PVOID
LOCAL path:PVOID
LOCAL fontFam:PVOID
LOCAL strFrmt:PVOID
LOCAL rectf:RectF
LOCAL layout:RectF
LOCAL cc:DWORD
LOCAL font:PVOID
LOCAL fontSize:REAL4
LOCAL n:DWORD

LOCAL rect:RECT
LOCAL pt[4]:PointF
LOCAL f4:REAL4

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,NULL
	.elseif uMsg == WM_DESTROY
		invoke DeleteObject,rv(GetWindowLong,hWnd,WND_DATA.hdc)
	.elseif uMsg == WM_CREATE
		mov esi,rv(GetDC,rv(GetDesktopWindow))
		mov ebx,rv(CreateCompatibleDC,esi)
		mov edi,rv(GetSystemMetrics,SM_CXSCREEN)
		invoke DeleteObject,rv(SelectObject,ebx,rv(CreateCompatibleBitmap,esi,edi,rv(GetSystemMetrics,SM_CYSCREEN)))
		invoke ReleaseDC,rv(GetDesktopWindow),esi
		invoke SetWindowLong,hWnd,WND_DATA.hdc,ebx
		
		;/* split unicode string by lines and stor them in an pointer array */
		invoke wszLineArray,OFFSET wszTitel
		push ecx		
		invoke SetWindowLong,hWnd,WND_DATA.ppwsz,eax
		pop ecx
		push ecx
		invoke SetWindowLong,hWnd,WND_DATA.nLines,ecx
		
		;/* 20 = font hight */
		pop ecx
		mov eax,20
		imul eax,ecx
		invoke SetWindowLong,hWnd,WND_DATA.dwOffset,eax
		
		invoke SetTimer,hWnd,100,100,0
		
	.elseif uMsg == WM_TIMER
		invoke GetClientRect,hWnd,ADDR rect
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hdc)
		mov edi,rv(GetWindowLong,hWnd,WND_DATA.dwOffset)
		invoke GdipCreateFromHDC,ebx,ADDR graphics
		invoke GdipGraphicsClear,graphics,ColorsWhite
		invoke GdipSetPageUnit,graphics,UnitPixel
		invoke GdipCreateStringFormat,0,LANG_NEUTRAL,ADDR strFrmt
		invoke GdipCreateFontFamilyFromName,wsz$("Arial"),0,ADDR fontFam
		invoke GdipCreatePath,0,ADDR path
		invoke GdipCreatePen1,ColorsBlack,FP4(1.0),UnitPixel,ADDR pen
		invoke GdipCreateMatrix,ADDR matrix
		invoke GdipCreateFont,fontFam,FP4(20.0),0,UnitPixel,ADDR font
		
		mov layout.x,0
		mov layout.y,0
		mov layout._Width,0
		mov layout.Height,0
		mov esi,rv(GetWindowLong,hWnd,WND_DATA.nLines)
		mov n,esi
		dec esi
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.ppwsz)
		.while SDWORD ptr esi >= 0
			invoke GdipMeasureString,graphics,PWCHAR ptr [ebx+esi*4],-1,font,ADDR layout,strFrmt,ADDR rectf,0,0
			invoke GdipGetFontSize,font,ADDR fontSize
			fld rectf._Width
			fisubr rect.right
			fdiv FP4(2.0)
			fstp pt.x
			mov DWORD ptr [esp-4],edi
			fild DWORD ptr [esp-4]
			fiadd rect.bottom
			mov DWORD ptr [esp-4],esi
			fild n
			fisub DWORD ptr [esp-4]
			fmul fontSize
			fsubp st(1),st
			fst pt.y
			
			fadd fontSize
			fistp DWORD ptr [esp-4]
			fld pt.y
			fistp DWORD ptr [esp-8]
			mov eax,rect.bottom
			.if DWORD ptr [esp-4] > 0 && DWORD ptr [esp-8] < eax
				mov pt[1*8].x,0
				mov pt[1*8].y,0
				invoke GdipAddPathString,path,PWCHAR ptr [ebx+esi*4],-1,fontFam,0,fontSize,ADDR pt,strFrmt
			.endif
			dec esi
		.endw

		mov pt[0*8].y,0
		mov pt[1*8].y,0
		mov pt[2*8].x,0
	
		fild rect.right
		fld st
		fld st
		fdiv FP4(3.0)
		fstp pt[0*8].x
		fmul FP4(0.66666)
		fstp pt[1*8].x
		fstp pt[3*8].x
		fild rect.bottom
		fst pt[2*8].y
		fstp pt[3*8].y
		
		fild rect.right
		fstp rect.right
		fild rect.bottom
		fstp rect.bottom
		
		;/* the magic function */
		invoke GdipWarpPath,path,matrix,ADDR pt,4,FP4(0.0),FP4(0.0),rect.right,rect.bottom,WarpModePerspective,0
		
		;/* outline the path */
		invoke GdipDrawPath,graphics,pen,path
		
		invoke GdipDeletePath,path
		invoke GdipDeletePen,pen
		invoke GdipDeleteMatrix,matrix
		invoke GdipDeleteFontFamily,fontFam
		invoke GdipDeleteStringFormat,strFrmt
		invoke GdipDeleteFont,font
		invoke GdipDeleteGraphics,graphics	
		
		;/* go one pixel forward */
		dec edi
		invoke SetWindowLong,hWnd,WND_DATA.dwOffset,edi

		invoke InvalidateRect,hWnd,0,0
	.elseif uMsg == WM_PAINT
		invoke BeginPaint,hWnd,ADDR ps
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hdc)
		mov edx,ps.rcPaint.right
		sub edx,ps.rcPaint.left
		mov ecx,ps.rcPaint.bottom
		sub ecx,ps.rcPaint.top
		invoke BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,ebx,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
		invoke EndPaint,hWnd,ADDR ps	
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
WndProc endp

end main
